#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Black
#property indicator_color2 Blue
#property indicator_color3 Red

double g_ibuf_76[];
double g_ibuf_80[];
double g_ibuf_84[];
double g_ibuf_88[];
double g_ibuf_92[];
extern int   g1 = 2;
extern int   g2 = 62;
extern int   g3 = 2;
extern string  KG_Wave_Major   = "g1=33, g2=62, g3=2";
extern string  KG_Wave_Minor   = "g1=16, g2=62, g3=2";
extern string  KG_Wave_Micro   = "g1=6,  g2=62, g3=2";
extern string  KG_Wave_Trigger = "g1=2,  g2=62, g3=2";


int init() {
   IndicatorBuffers(5);
   SetIndexStyle(0, DRAW_NONE);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   IndicatorDigits(Digits + 2);
   SetIndexDrawBegin(0, 38);
   SetIndexDrawBegin(1, 38);
   SetIndexDrawBegin(2, 38);
   SetIndexBuffer(0, g_ibuf_76);
   SetIndexBuffer(1, g_ibuf_80);
   SetIndexBuffer(2, g_ibuf_84);
   SetIndexBuffer(3, g_ibuf_88);
   SetIndexBuffer(4, g_ibuf_92);
   SetIndexLabel(1, NULL);
   SetIndexLabel(2, NULL);
   return (0);
}

int start() {
   double l_ima_on_arr_8;
   double l_ima_on_arr_16;
   double l_istochastic_24;
   double l_istochastic_32;
   int li_4 = IndicatorCounted();
   if (li_4 > 0) li_4--;
   int li_0 = Bars - li_4;
   for (int li_40 = 0; li_40 < li_0; li_40++) g_ibuf_88[li_40] = iMA(NULL, 0, g1, 0, MODE_LWMA, PRICE_CLOSE, li_40) - iMA(NULL, 0, g2, 0, MODE_LWMA, PRICE_CLOSE, li_40);
   for (li_40 = 0; li_40 < li_0; li_40++) g_ibuf_92[li_40] = iMAOnArray(g_ibuf_88, Bars, g3, 0, MODE_LWMA, li_40);
   bool li_44 = TRUE;
   for (li_40 = li_0 - 1; li_40 >= 0; li_40--) {
      l_ima_on_arr_16 = iMAOnArray(g_ibuf_92, Bars, g3, 0, MODE_LWMA, li_40);
      l_ima_on_arr_8 = iMAOnArray(g_ibuf_92, Bars, g3, 0, MODE_LWMA, li_40 + 1);
      if (l_ima_on_arr_16 >= l_ima_on_arr_8) li_44 = TRUE;
      if (l_ima_on_arr_16 <= l_ima_on_arr_8) li_44 = FALSE;
      if (!li_44) {
         g_ibuf_84[li_40] = l_ima_on_arr_16;
         g_ibuf_80[li_40] = 0.0;
      } else {
         g_ibuf_80[li_40] = l_ima_on_arr_16;
         g_ibuf_84[li_40] = 0.0;
      }
      g_ibuf_76[li_40] = l_ima_on_arr_16;
      l_istochastic_24 = iStochastic(NULL, 0, 62, 2, 2, MODE_LWMA, 0, MODE_MAIN, li_40);
      l_istochastic_32 = iStochastic(NULL, 0, 62, 2, 2, MODE_LWMA, 0, MODE_SIGNAL, li_40);
      IndicatorShortName("KG Wave Trigger : " + l_istochastic_24 + " " + l_istochastic_32);
   }
   return (0);
}